#ifndef STORAGEHANDLER_H
#define STORAGEHANDLER_H



#include <SPI.h>

#define SPI_READ 0x03
#define SPI_WRITE 0x02
#define SPI_ERASESECTOR 0x20
#define SPI_WRITEENABLE 0x06  // write enable


/**
 * Actual this class works only with 
 * Winbond
 * SPIFlash
 * 3V 64M-BIT
 * SERIAL FLASH MEMORY WITH
 * DUAL/QUAD SPI & QPI
 */
class StorageHandler {
    public:
        StorageHandler(int p_Pin_CS, int p_PageSize, int p_AddressBitCount = 16,
            uint32_t p_Clock = 4000000, BitOrder p_BitOrder = MSBFIRST, uint8_t p_DataMode = SPI_MODE0);
        ~StorageHandler();

    protected:
        int m_Pin_CS;
        int m_PageSize_Bytes = 256;
        int m_AddressBitCount = 16;
        SPISettings* m_SPISettings;
    public:
        
        void eraseSector(uint64_t p_Address);
        int readByteArray(uint64_t p_Address, char p_ByteArray[], int p_Offset, int p_BytesToRead);
        int writeByteArray(uint64_t p_Address, char p_ByteArray[], int p_Offset, int p_BytesToRead);


};

#endif